{*******************************************************}
{          Copyright (c) 1996-1997 AllexSoft            }
{                   Written by VSM                      }
{                   SOHO Components                     }
{*******************************************************}
unit VersionInfo;
interface
uses Windows;

function GetVersionInfoSection (Section : string): string;
function GetCompanyName: string;
function GetFileDescription: string;
function GetFileVersion: string;
function GetInternalName: string;
function GetLegalCopyright: string;
function GetLegalTrademarks: string;
function GetOriginalFilename: string;
function GetProductName: string;
function GetProductVersion: string;
function GetComments: string;
function GetEMailFromVersion: string;

implementation
uses SysUtils;

var VerBuf  : PChar;
    VerText : PChar;
    VerSize : DWORD; {D4}
    Temp : DWORD; {D4}
    SectionSize : DWORD; {D4}

function GetModuleName(Module: HMODULE): string;
var
  ModName: array[0..MAX_PATH] of Char;
begin
  SetString(Result, ModName, Windows.GetModuleFileName(Module, ModName, SizeOf(ModName)));
end;
    
procedure GetVersionInfo;
begin
  VerSize := GetFileVersionInfoSize(PChar(GetModuleName(HINstance)), Temp);
  if (VerSize<>0) then
  begin
    GetMem(VerBuf, VerSize);
    GetFileVersionInfo(PChar(GetModuleName(HINstance)), Temp, VerSize, VerBuf);
  end;
end;

function GetVersionInfoSection (Section : string): string;
var Tmp : array [0..254] of char;
begin
  Result := '';
  if VerSize = 0 then exit;
  StrPCopy(Tmp,'\StringFileInfo\040904E4\'+Section);
  VerQueryValue(VerBuf,Tmp,pointer(VerText),SectionSize);
  Result := StrPas(VerText);
end;

function GetCompanyName: string;
begin
  Result := GetVersionInfoSection('CompanyName');
end;

function GetFileDescription: string;
begin
  Result := GetVersionInfoSection('FileDescription');
end;

function GetFileVersion: string;
begin
  Result := GetVersionInfoSection('FileVersion');
end;

function GetInternalName: string;
begin
  Result := GetVersionInfoSection('InternalName');
end;

function GetLegalCopyright: string;
begin
  Result := GetVersionInfoSection('LegalCopyright');
end;

function GetLegalTrademarks: string;
begin
  Result := GetVersionInfoSection('LegalTrademarks');
end;

function GetOriginalFileName: string;
begin
  Result := GetVersionInfoSection('OriginalFilename');
end;

function GetProductName: string;
begin
  Result := GetVersionInfoSection('ProductName');
end;

function GetProductVersion: string;
begin
  Result := GetVersionInfoSection('ProductVersion');
end;

function GetComments: string;
begin
  Result := GetVersionInfoSection('Comments');
end;

function GetEMailFromVersion: string;
begin
  Result := GetVersionInfoSection('AuthorEMail');
end;

initialization
  GetVersionInfo;
finalization
  if VerSize<>0 then FreeMem(VerBuf, VerSize);
end.

